using System;
using System.Web;
using System.Web.UI.WebControls;


using System.IO;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web.UI;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.tool.xml;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    private DataTable GetData(string query)
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
            {
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    return dt;
                }
            }
        }
    }

    protected void ExportToWord(object sender, EventArgs e)
    {
        //Get the data from database into DataTable.
        string query = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers";
        DataTable dt = this.GetData(query);

        //Create a dummy GridView.
        GridView gvCustomers = new GridView();
        gvCustomers.DataSource = dt;
        gvCustomers.DataBind();

        Response.Clear();
        Response.Buffer = true;
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.doc");
        Response.Charset = "";
        Response.ContentType = "application/vnd.ms-word ";
        using (StringWriter sw = new StringWriter())
        {
            using (HtmlTextWriter hw = new HtmlTextWriter(sw))
            {
                gvCustomers.RenderControl(hw);
                Response.Output.Write(sw.ToString());
                Response.Flush();
                Response.End();
            }
        }
    }

    protected void ExportToExcel(object sender, EventArgs e)
    {
        //Get the data from database into DataTable.
        string query = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers";
        DataTable dt = this.GetData(query);

        //Create a dummy GridView.
        GridView gvCustomers = new GridView();
        gvCustomers.DataSource = dt;
        gvCustomers.DataBind();

        Response.Clear();
        Response.Buffer = true;
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.xls");
        Response.Charset = "";
        Response.ContentType = "application/vnd.ms-excel";
        using (StringWriter sw = new StringWriter())
        {
            using (HtmlTextWriter hw = new HtmlTextWriter(sw))
            {
                foreach (GridViewRow row in gvCustomers.Rows)
                {
                    //Apply text style to each Row.
                    row.Attributes.Add("class", "textmode");
                }
                gvCustomers.RenderControl(hw);

                //Style to format numbers to string.
                string style = @"<style> .textmode { mso-number-format:\@; } </style>";
                Response.Write(style);
                Response.Output.Write(sw.ToString());
                Response.Flush();
                Response.End();
            }
        }
    }

    protected void ExportToPDF(object sender, EventArgs e)
    {
        //Get the data from database into DataTable.
        string query = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers";
        DataTable dt = this.GetData(query);

        //Create a dummy GridView.
        GridView gvCustomers = new GridView();
        gvCustomers.DataSource = dt;
        gvCustomers.DataBind();

        Response.ContentType = "application/pdf";
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.pdf");
        Response.Cache.SetCacheability(HttpCacheability.NoCache);
        using (StringWriter sw = new StringWriter())
        {
            using (HtmlTextWriter hw = new HtmlTextWriter(sw))
            {
                gvCustomers.RenderControl(hw);
                using (StringReader sr = new StringReader(sw.ToString()))
                {
                    using (Document pdfDoc = new Document(PageSize.A4, 10f, 10f, 10f, 0f))
                    {

                        using (PdfWriter writer = PdfWriter.GetInstance(pdfDoc, Response.OutputStream))
                        {
                            pdfDoc.Open();
                            XMLWorkerHelper.GetInstance().ParseXHtml(writer, pdfDoc, sr);
                            pdfDoc.Close();
                            Response.Cache.SetCacheability(HttpCacheability.NoCache);
                            Response.Write(pdfDoc);
                            Response.End();
                        }
                    }
                }
            }
        }
    }

    protected void ExportToCSV(object sender, EventArgs e)
    {
        //Get the data from database into DataTable.
        string query = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers";
        DataTable dt = this.GetData(query);

        Response.Clear();
        Response.Buffer = true;
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.csv");
        Response.Charset = "";
        Response.ContentType = "application/text";

        StringBuilder sb = new StringBuilder();
        foreach (DataColumn column in dt.Columns)
        {
            //Append data with separator.
            sb.Append(column.ColumnName + ',');
        }
        //Append new line character.
        sb.Append("\r\n");
        foreach (DataRow row in dt.Rows)
        {
            foreach (DataColumn column in dt.Columns)
            {
                //Append data with separator.
                sb.Append(row[column.ColumnName].ToString() + ',');
            }
            //Append new line character.
            sb.Append("\r\n");
        }
        Response.Output.Write(sb.ToString());
        Response.Flush();
        Response.End();
    }
}
