Imports System.IO
Imports System.Data
Imports System.Data.SqlClient
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.tool.xml

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    End Sub

    Private Function GetData(ByVal query As String) As DataTable
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub ExportToWord(ByVal sender As Object, ByVal e As EventArgs)
        'Get the data from database into DataTable.
        Dim query As String = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers"
        Dim dt As DataTable = Me.GetData(query)

        'Create a dummy GridView.
        Dim gvCustomers As GridView = New GridView()
        gvCustomers.DataSource = dt
        gvCustomers.DataBind()

        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.doc")
        Response.Charset = ""
        Response.ContentType = "application/vnd.ms-word "
        Using sw As StringWriter = New StringWriter()
            Using hw As HtmlTextWriter = New HtmlTextWriter(sw)
                gvCustomers.RenderControl(hw)
                Response.Output.Write(sw.ToString())
                Response.Flush()
                Response.End()
            End Using
        End Using
    End Sub

    Protected Sub ExportToExcel(ByVal sender As Object, ByVal e As EventArgs)
        'Get the data from database into DataTable.
        Dim query As String = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers"
        Dim dt As DataTable = Me.GetData(query)

        'Create a dummy GridView.
        Dim gvCustomers As GridView = New GridView()
        gvCustomers.DataSource = dt
        gvCustomers.DataBind()

        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.xls")
        Response.Charset = ""
        Response.ContentType = "application/vnd.ms-excel"
        Using sw As StringWriter = New StringWriter()
            Using hw As HtmlTextWriter = New HtmlTextWriter(sw)
                For Each row As GridViewRow In gvCustomers.Rows
                    'Apply text style to each Row.
                    row.Attributes.Add("class", "textmode")
                Next
                gvCustomers.RenderControl(hw)
                'Style to format numbers to string.
                Dim style As String = "<style> .textmode { mso-number-format:\@; } </style>"
                Response.Write(style)
                Response.Output.Write(sw.ToString())
                Response.Flush()
                Response.End()
            End Using
        End Using
    End Sub

    Protected Sub ExportToPDF(ByVal sender As Object, ByVal e As EventArgs)
        'Get the data from database into DataTable.
        Dim query As String = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers"
        Dim dt As DataTable = Me.GetData(query)

        'Create a dummy GridView.
        Dim gvCustomers As GridView = New GridView()
        gvCustomers.DataSource = dt
        gvCustomers.DataBind()

        Response.ContentType = "application/pdf"
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.pdf")
        Response.Cache.SetCacheability(HttpCacheability.NoCache)
        Using sw As StringWriter = New StringWriter()
            Using hw As HtmlTextWriter = New HtmlTextWriter(sw)
                gvCustomers.RenderControl(hw)
                Using sr As StringReader = New StringReader(sw.ToString())
                    Using pdfDoc As Document = New Document(PageSize.A4, 10.0F, 10.0F, 10.0F, 0F)
                        Using writer As PdfWriter = PdfWriter.GetInstance(pdfDoc, Response.OutputStream)
                            pdfDoc.Open()
                            XMLWorkerHelper.GetInstance().ParseXHtml(writer, pdfDoc, sr)
                            pdfDoc.Close()
                            Response.Cache.SetCacheability(HttpCacheability.NoCache)
                            Response.Write(pdfDoc)
                            Response.End()
                        End Using
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub ExportToCSV(ByVal sender As Object, ByVal e As EventArgs)
        'Get the data from database into DataTable.
        Dim query As String = "SELECT CustomerID, ContactName, City, PostalCode FROM Customers"
        Dim dt As DataTable = Me.GetData(query)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.csv")
        Response.Charset = ""
        Response.ContentType = "application/text"

        Dim sb As StringBuilder = New StringBuilder()
        For Each column As DataColumn In dt.Columns
            'Append data with separator.
            sb.Append(column.ColumnName + ","c)
        Next
        'Append new line character.
        sb.Append(vbCrLf)
        For Each row As DataRow In dt.Rows
            For Each column As DataColumn In dt.Columns
                'Append data with separator.
                sb.Append(row(column.ColumnName).ToString() + ","c)
            Next
            'Append new line character.
            sb.Append(vbCrLf)
        Next
        Response.Output.Write(sb.ToString())
        Response.Flush()
        Response.End()
    End Sub
End Class
